
#include <sys/stat.h>
#include "populateGraph.cpp"

using namespace std;

#define ERR(msg) {fprintf(stderr, "%s\n", msg); exit(2);}

int main(int argc,char const *argv[]) {
    int k = 5;
    int count = 1;
    long seed = -1;

    vector<string> Files;

    //options parsing

    for (int i = 1; i < argc; i++) {
        string arg(argv[i]);
        
        if (arg == "-c") {
            i++;
            count = atoi(argv[i]);
        }
        else if (arg == "-k") {
            i++;
            k = atoi(argv[i]);
        }
        else if (arg == "-s") {
            i++;
            seed = atol(argv[i]);
        }
        else {
            Files.push_back(arg);
        }
    }

    UndirectedWeightedGraph graph;

    for (string File : Files) {

        ifstream s(File);
        if (!s) ERR("errore di apertura del file")
        
        stringstream buffer;
        buffer << s.rdbuf();
        //file parsing
        vector<phrase> phrases = parseFile(buffer.str());

        //graph population
        populateGraph(&graph, phrases);
    }

    vector<vector<Edge>> Sol = graph.findSol(count, k, seed);
    graph.printSol(Sol);

    return 0;

}